#lang typed/racket
(require "ast.rkt")
(require racket/cmdline)
(require/typed "parser.rkt"
  [parse-from-port (-> Input-Port CoreProgram)]
  [parse-from-string (-> String CoreProgram)])



(module* main #f
  (: filename Path-String)
  (define filename
    (let ([result (command-line
                   #:program "core-parser"
                   #:args (filename)
                   filename)])
      (if (path-string? result)
          result
          (error "Commandline parser returned unexpected results"))))


  (pretty-print (parse-from-port
                 (open-input-file filename))))

(provide parse-from-port parse-from-string)
